[![KendoReact NPM Banner](https://raw.githubusercontent.com/telerik/kendo-react/master/images/kendoreact-github-banner.png)](https://www.telerik.com/kendo-react-ui/components/free?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-upload&utm_content=banner)

# KendoReact Upload Component for React

> **Important**
>
> -   This package is а part of [KendoReact](https://www.telerik.com/kendo-react-ui?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-upload)&mdash;an enterprise-grade UI library with 120+ free and premium components.
> -   It provides a premium KendoReact component. You will need to install a license key when adding the package to your project. For more information, please refer to the [KendoReact My License page](https://www.telerik.com/kendo-react-ui/components/my-license/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-upload).
> -   To receive a license key, you need to either [purchase a license](https://www.telerik.com/kendo-react-ui/pricing?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-upload) or register for a [free trial](https://www.telerik.com/try/kendo-react-ui?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-upload). Doing so indicates that you [accept the KendoReact License Agreement](https://www.telerik.com/purchase/license-agreement/progress-kendoreact?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-upload).
> - The 30-day free trial gives you access to all KendoReact components and their full functionality. Additionally, for the period of your trial, you can use our legendary technical support provided directly by the KendoReact dev team!
>
> [Start using KendoReact](https://www.telerik.com/try/kendo-react-ui?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-upload) and speed up your development process!
>
> If you're looking for free React components, check out [Get Started with KendoReact Free](https://www.telerik.com/kendo-react-ui/components/free).

The React Upload component, part of KendoReact, helps users transfer files from their file systems to dedicated server handlers.

## React Upload

Among the features which the KendoReact Upload component delivers are:

-   [Disabled Upload](https://www.telerik.com/kendo-react-ui/components/upload/disabled-state/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-upload)&mdash;Completely disable the upload functionality in certain conditions.
-   [Modes of operation](https://www.telerik.com/kendo-react-ui/components/upload/modes/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-upload)&mdash;Control which file types can be uploaded or execute follow-up logic based on certain scenario.
-   [Credentials and additional data](https://www.telerik.com/kendo-react-ui/components/upload/credentials/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-upload)&mdash;Send cookies and/or headers for cross-site requests or additional data.
-   [File processing](https://www.telerik.com/kendo-react-ui/components/upload/file-processing/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-upload)&mdash;Provides different configuration options for controlling the way files are processed during upload. For example, automatic upload, single or multiple files upload, or upload of batches of files.
-   [File restrictions](https://www.telerik.com/kendo-react-ui/components/upload/restrictions/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-upload)&mdash;Restrict certain file uploads, based on their file size or extension.
-   [Dragging and dropping](https://www.telerik.com/kendo-react-ui/components/upload/drag-and-drop/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-upload)&mdash;For easy use and delightful experiences, the component has built-in drag and drop functionality.
-   [Custom renderer](https://www.telerik.com/kendo-react-ui/components/upload/custom-rendering/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-upload)&mdash;You can apply your own look and feel to the uploaded files list.
-   [External Drop Zone](https://www.telerik.com/kendo-react-ui/components/upload/external-drop-zone/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-upload)&mdash;The ExternalDropZone helps users to drag and drop files from their file systems to a dedicated user interface. The files are then sent to the specified server handlers, which are configured to receive them.
-   [Globalization](https://www.telerik.com/kendo-react-ui/components/upload/globalization/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-upload)&mdash;By using the available globalization options in KendoReact, you can translate the Upload messages by adapting them to specific culture locales.
-   [Keyboard navigation](https://www.telerik.com/kendo-react-ui/components/upload/keyboard-navigation/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-upload)&mdash;Built-in keyboard shortcuts for usability and navigation in the component.
-   [Theme support](https://www.telerik.com/kendo-react-ui/components/styling/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-upload)&mdash;The KendoReact Upload, as well as all 100+ components in the KendoReact suite, are styled in three polished themes (Bootstrap, Material, and Default) and can be further customized to match your specific design guidelines.

## Support Options

For any issues you might encounter while working with the KendoReact Upload, use any of the available support channels:

-   Industry-leading technical support&mdash;KendoReact paid license holders and users with an active (free) trial license can take advantage of our outstanding customer support. To submit a ticket, use [the dedicated KendoReact support system](https://www.telerik.com/account/support-center/contact-us/technical-support?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-upload).
-   Product forums&mdash;The [KendoReact forums](https://www.telerik.com/forums/kendo-ui-react?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-upload) are part of the free support you can get from the community and from the KendoReact team.
-   Feedback portal&mdash;The [KendoReact feedback portal](https://feedback.telerik.com/kendo-react-ui?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-upload) is where you can request and vote for new features to be added.

## Resources

-   [Getting Started with KendoReact](https://www.telerik.com/kendo-react-ui/components/getting-started/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-upload)
-   [Get Started with KendoReact Free](https://www.telerik.com/kendo-react-ui/components/free)
-   [Get Started with the KendoReact Upload](https://www.telerik.com/kendo-react-ui/components/upload/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-upload)
-   [API Reference of the KendoReact Upload](https://www.telerik.com/kendo-react-ui/components/upload/api/UploadProps/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-upload)
-   [KendoReact Roadmap](https://www.telerik.com/support/whats-new/kendo-react-ui/roadmap?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-upload)
-   [Blogs](https://www.telerik.com/blogs/tag/kendoreact?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-upload)
-   [Demos, documentation, and component reference](https://www.telerik.com/kendo-react-ui/components/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-upload)
-   [KendoReact pricing and licensing](https://www.telerik.com/kendo-react-ui/pricing?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-upload)
-   [Changelog](https://www.telerik.com/kendo-react-ui/components/changelogs/ui-for-react/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-upload)

High-level component overview pages

-   [React External Drop Zone Component](https://www.telerik.com/kendo-react-ui/external-drop-zone)
-   [React Upload Component](https://www.telerik.com/kendo-react-ui/upload)

_Copyright © 2025 Progress Software Corporation and/or its subsidiaries or affiliates. All Rights Reserved._

_Progress, Telerik, and certain product names used herein are trademarks or registered trademarks of Progress Software Corporation and/or one of its subsidiaries or affiliates in the U.S. and/or other countries._
